<?php
namespace app\api\controller;
use think\Controller;
use think\Db;
class Uploadfile extends Controller{
	
	public function index(){
		echo 123;
		
	}
	
	public function upload(){

		$tempdir = "./test/tempdir"; //这里分片的文件指定了一个临时目录, 后面会用到
		$savedir = "./test"; //文件存储目录
		$flag = input("flag",0);//接收参数flag 如果没有这个参数就默认为0, 如果flag=1,表示要组装分片
		
		$allowExt = ['pdf','zip','txt']; //允许文件格式
		$size = 1024 * 1024 * 5; //允许分片大小
		
		if($flag == 0){
			//这里是上传分片
			$file = $_FILES['file']['tmp_name'];  //接收到这个分片
			$tempfilename = input("tempfilename");  //接收到这个分片的名称, (注意,这个名称中含有排序信息)
			
			//验证格式
			$temp= explode('.',$tempfilename);
			$ext= strtolower(end($temp));
			
			if(!in_array($ext,$allowExt)){
				return json(['error'=>1,'msg'=>$ext.'格式不支持']);
			}
			
			//验证大小
			if($_FILES['file']['size']>$size){
				return json(['error'=>1,'msg'=>'文件太大了']);
			}
			
			
			//如果临时目录不存在,则创建一个临时目录
			if(!file_exists($tempdir)){
				mkdir($tempdir,0755,true);
			}
				
			$move = move_uploaded_file($file,$tempdir.'/'.$tempfilename); //存储文件
			if($move){  // 这里把分片的文件保存在了临时目录中, 返回的结果有点简单, 可以根据自已的需求返回相应的数据
				return json(['error'=>0]);
			}else{
				return json(['error'=>1,'msg'=>'文件转存失败']);
			}
			
		}else if($flag == 1){
			
			//如果flag 为 1 表示, 分片已上传完成了
			$filename = input("filename");
			
			//验证格式
			$temp=explode('.', $filename);
			$ext= strtolower(end($temp));
			if(!in_array($ext,$allowExt)){
				return json(['error'=>1,'msg'=>'格式不支持']);
			}
			
			//通过文件名的字符串匹配, 找上所有的分片, 返回一个文件路径的数组
			$fileArr = glob($tempdir."/*".$filename);
			// 这里的 * 是一个通配符, 它可以了所以的文件名中 包含的 $filename 的文都找到
			//说明一下, $fileArr中的数组的顺序不是我们想要的 , 所以我们新建一个数组来 整理一下顺序
			$newfileArr = [];
			foreach($fileArr as $f){
			//在js前端我们把文件的名称 前加了 序号+"_", 所以我们可以取到文件名之后, 通过 下划线来分开并把序中写在 key 中
				$filebasename = basename($f); //$f是一个个的 路径, 这里使用 basename 得到文件名
				$filebasenamesplit = explode("_",$filebasename); //通过 下划线分割文件名, 
				$newfileArr[$filebasenamesplit[0]] = $f;    //构造了一个新的数组, 其中 数组的key 就是 顺序号, 数组的值就是 分片文件的路径
			}
			//分片的序号和路径都准备好了, 就可以组装了
			$num = count($newfileArr);  //得到的所有分片的个数, 为后面使用for 循环做准务
			
			
			//开始使用for 循环来组装
			$newfilename = $savedir."/".date('Ymd').uniqid().'.'.$ext; //这里为组装后的文件起一个名字, 可随意
			for($i = 1;$i<=$num;$i++){
				//这里以追加的方式, 把分片文件都写入到了一个文件中
				file_put_contents($newfilename,file_get_contents($newfileArr[$i]),FILE_APPEND);
			}
			
			//删除临时文件中的分片文件, 这里可以使用 try catch来判断是否有错误
			foreach($newfileArr as $fi){
				unlink($fi);
			}
			
		}
	}
	
}